/*
 * generated by Fujaba - CodeGen2
 */
package de.uni_kassel.pmss2010.castle;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Castle
{



   /**
    * <pre>
    *           0..1     rooms     0..n
    * Castle ------------------------- Room
    *           studyRightUniversity               rooms
    * </pre>
    */
   public static final String PROPERTY_ROOMS = "rooms";

   @Property( name = PROPERTY_ROOMS, partner = Room.PROPERTY_STUDY_RIGHT_UNIVERSITY, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Room> rooms;

   @Property( name = PROPERTY_ROOMS )
   public Set<? extends Room> getRooms()
   {
      return ((this.rooms == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.rooms));
   }

   @Property( name = PROPERTY_ROOMS )
   public boolean addToRooms (Room value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.rooms == null)
         {
            this.rooms = new FHashSet<Room> ();

         }
      
         changed = this.rooms.add (value);
         if (changed)
         {
            value.setStudyRightUniversity (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_ROOMS )
   public Castle withRooms (Room value)
   {
      addToRooms (value);
      return this;
   }

   public Castle withoutRooms (Room value)
   {
      removeFromRooms (value);
      return this;
   }


   public boolean removeFromRooms (Room value)
   {
      boolean changed = false;

      if ((this.rooms != null) && (value != null))
      {
      
         changed = this.rooms.remove (value);
         if (changed)
         {
            value.setStudyRightUniversity (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_ROOMS )
   public void removeAllFromRooms (){
   
      Room tmpValue;
      Iterator<? extends Room> iter = this.iteratorOfRooms ();
      while (iter.hasNext ())
      {
         tmpValue = (Room) iter.next ();
         this.removeFromRooms (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_ROOMS )
   public boolean hasInRooms (Room value)
   {
      return ((this.rooms != null) &&
              (value != null) &&
              this.rooms.contains (value));
   }

   @Property( name = PROPERTY_ROOMS )
   public Iterator<? extends Room> iteratorOfRooms ()
   {
      return ((this.rooms == null)
              ? FEmptyIterator.<Room>get ()
              : this.rooms.iterator ());
   }

   @Property( name = PROPERTY_ROOMS )
   public int sizeOfRooms ()
   {
      return ((this.rooms == null)
              ? 0
              : this.rooms.size ());
   }

   public void removeYou()
   {
      this.removeAllFromRooms ();
   }
}


