/*
 * generated by Fujaba - CodeGen2
 */
package de.uni_kassel.pmss2010.castle;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath


public class Guard
{



   public static final String PROPERTY_COSTS = "costs";

   @Property( name = PROPERTY_COSTS, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private int costs;

   @Property( name = PROPERTY_COSTS )
   public void setCosts (int value)
   {
      this.costs = value;
   }

   public Guard withCosts (int value)
   {
      setCosts (value);
      return this;
   }

   @Property( name = PROPERTY_COSTS )
   public int getCosts ()
   {
      return this.costs;
   }

   public static final String PROPERTY_LEVEL = "level";

   @Property( name = PROPERTY_LEVEL, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private int level;

   @Property( name = PROPERTY_LEVEL )
   public void setLevel (int value)
   {
      this.level = value;
   }

   public Guard withLevel (int value)
   {
      setLevel (value);
      return this;
   }

   @Property( name = PROPERTY_LEVEL )
   public int getLevel ()
   {
      return this.level;
   }

   /**
    * <pre>
    *           0..n     friendlyGuard     0..1
    * Guard ------------------------- Person
    *           friendlyGuard               person
    * </pre>
    */
   public static final String PROPERTY_PERSON = "person";

   @Property( name = PROPERTY_PERSON, partner = Person.PROPERTY_FRIENDLY_GUARD, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Person person;

   @Property( name = PROPERTY_PERSON )
   public boolean setPerson (Person value)
   {
      boolean changed = false;

      if (this.person != value)
      {
      
         Person oldValue = this.person;
         Guard source = this;
         if (this.person != null)
         {
            this.person = null;
            oldValue.removeFromFriendlyGuard (this);
         }
         this.person = value;

         if (value != null)
         {
            value.addToFriendlyGuard (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PERSON )
   public Guard withPerson (Person value)
   {
      setPerson (value);
      return this;
   }

   public Person getPerson ()
   {
      return this.person;
   }

   /**
    * <pre>
    *           0..1     guards     0..1
    * Guard ------------------------- Room
    *           guard               room
    * </pre>
    */
   public static final String PROPERTY_ROOM = "room";

   @Property( name = PROPERTY_ROOM, partner = Room.PROPERTY_GUARD, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Room room;

   @Property( name = PROPERTY_ROOM )
   public boolean setRoom (Room value)
   {
      boolean changed = false;

      if (this.room != value)
      {
      
         Room oldValue = this.room;
         Guard source = this;
         if (this.room != null)
         {
            this.room = null;
            oldValue.setGuard (null);
         }
         this.room = value;

         if (value != null)
         {
            value.setGuard (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_ROOM )
   public Guard withRoom (Room value)
   {
      setRoom (value);
      return this;
   }

   public Room getRoom ()
   {
      return this.room;
   }

   public void removeYou()
   {
      this.setPerson (null);
      this.setRoom (null);
   }
}


