/*
 * generated by Fujaba - CodeGen2
 */
package de.uni_kassel.pmss2010.castle;
import de.upb.tools.sdm.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Person
{



   public void bribeGuard ()
   {
      boolean fujaba__Success = false;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // collabStat call
         this.sayHello();
         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;
   }

   public void browseRoom ()
   {
   }

   public void collectItems ()
   {
   }

   public static final String PROPERTY_EXPERIENCE = "experience";

   @Property( name = PROPERTY_EXPERIENCE, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private int experience;

   @Property( name = PROPERTY_EXPERIENCE )
   public void setExperience (int value)
   {
      this.experience = value;
   }

   public Person withExperience (int value)
   {
      setExperience (value);
      return this;
   }

   @Property( name = PROPERTY_EXPERIENCE )
   public int getExperience ()
   {
      return this.experience;
   }

   /**
    * <pre>
    *           0..1     friendlyGuard     0..n
    * Person ------------------------- Guard
    *           person               friendlyGuard
    * </pre>
    */
   public static final String PROPERTY_FRIENDLY_GUARD = "friendlyGuard";

   @Property( name = PROPERTY_FRIENDLY_GUARD, partner = Guard.PROPERTY_PERSON, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Guard> friendlyGuard;

   @Property( name = PROPERTY_FRIENDLY_GUARD )
   public Set<? extends Guard> getFriendlyGuard()
   {
      return ((this.friendlyGuard == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.friendlyGuard));
   }

   @Property( name = PROPERTY_FRIENDLY_GUARD )
   public boolean addToFriendlyGuard (Guard value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.friendlyGuard == null)
         {
            this.friendlyGuard = new FHashSet<Guard> ();

         }
      
         changed = this.friendlyGuard.add (value);
         if (changed)
         {
            value.setPerson (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_FRIENDLY_GUARD )
   public Person withFriendlyGuard (Guard value)
   {
      addToFriendlyGuard (value);
      return this;
   }

   public Person withoutFriendlyGuard (Guard value)
   {
      removeFromFriendlyGuard (value);
      return this;
   }


   public boolean removeFromFriendlyGuard (Guard value)
   {
      boolean changed = false;

      if ((this.friendlyGuard != null) && (value != null))
      {
      
         changed = this.friendlyGuard.remove (value);
         if (changed)
         {
            value.setPerson (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_FRIENDLY_GUARD )
   public void removeAllFromFriendlyGuard (){
   
      Guard tmpValue;
      Iterator<? extends Guard> iter = this.iteratorOfFriendlyGuard ();
      while (iter.hasNext ())
      {
         tmpValue = (Guard) iter.next ();
         this.removeFromFriendlyGuard (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_FRIENDLY_GUARD )
   public boolean hasInFriendlyGuard (Guard value)
   {
      return ((this.friendlyGuard != null) &&
              (value != null) &&
              this.friendlyGuard.contains (value));
   }

   @Property( name = PROPERTY_FRIENDLY_GUARD )
   public Iterator<? extends Guard> iteratorOfFriendlyGuard ()
   {
      return ((this.friendlyGuard == null)
              ? FEmptyIterator.<Guard>get ()
              : this.friendlyGuard.iterator ());
   }

   @Property( name = PROPERTY_FRIENDLY_GUARD )
   public int sizeOfFriendlyGuard ()
   {
      return ((this.friendlyGuard == null)
              ? 0
              : this.friendlyGuard.size ());
   }

   /**
    * <pre>
    *           0..1     isIn     0..1
    * Person ------------------------- Room
    *           student               isIn
    * </pre>
    */
   public static final String PROPERTY_IS_IN = "isIn";

   @Property( name = PROPERTY_IS_IN, partner = Room.PROPERTY_STUDENT, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Room isIn;

   @Property( name = PROPERTY_IS_IN )
   public boolean setIsIn (Room value)
   {
      boolean changed = false;

      if (this.isIn != value)
      {
      
         Room oldValue = this.isIn;
         Person source = this;
         if (this.isIn != null)
         {
            this.isIn = null;
            oldValue.setStudent (null);
         }
         this.isIn = value;

         if (value != null)
         {
            value.setStudent (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_IS_IN )
   public Person withIsIn (Room value)
   {
      setIsIn (value);
      return this;
   }

   public Room getIsIn ()
   {
      return this.isIn;
   }

   /**
    * <pre>
    *           0..1     items     0..n
    * Person ------------------------- Item
    *           person               items
    * </pre>
    */
   public static final String PROPERTY_ITEMS = "items";

   @Property( name = PROPERTY_ITEMS, partner = Item.PROPERTY_PERSON, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Item> items;

   @Property( name = PROPERTY_ITEMS )
   public Set<? extends Item> getItems()
   {
      return ((this.items == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.items));
   }

   @Property( name = PROPERTY_ITEMS )
   public boolean addToItems (Item value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.items == null)
         {
            this.items = new FHashSet<Item> ();

         }
      
         changed = this.items.add (value);
         if (changed)
         {
            value.setPerson (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_ITEMS )
   public Person withItems (Item value)
   {
      addToItems (value);
      return this;
   }

   public Person withoutItems (Item value)
   {
      removeFromItems (value);
      return this;
   }


   public boolean removeFromItems (Item value)
   {
      boolean changed = false;

      if ((this.items != null) && (value != null))
      {
      
         changed = this.items.remove (value);
         if (changed)
         {
            value.setPerson (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_ITEMS )
   public void removeAllFromItems (){
   
      Item tmpValue;
      Iterator<? extends Item> iter = this.iteratorOfItems ();
      while (iter.hasNext ())
      {
         tmpValue = (Item) iter.next ();
         this.removeFromItems (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_ITEMS )
   public boolean hasInItems (Item value)
   {
      return ((this.items != null) &&
              (value != null) &&
              this.items.contains (value));
   }

   @Property( name = PROPERTY_ITEMS )
   public Iterator<? extends Item> iteratorOfItems ()
   {
      return ((this.items == null)
              ? FEmptyIterator.<Item>get ()
              : this.items.iterator ());
   }

   @Property( name = PROPERTY_ITEMS )
   public int sizeOfItems ()
   {
      return ((this.items == null)
              ? 0
              : this.items.size ());
   }

   public static final String PROPERTY_MONEY = "money";

   @Property( name = PROPERTY_MONEY, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private int money;

   @Property( name = PROPERTY_MONEY )
   public void setMoney (int value)
   {
      this.money = value;
   }

   public Person withMoney (int value)
   {
      setMoney (value);
      return this;
   }

   @Property( name = PROPERTY_MONEY )
   public int getMoney ()
   {
      return this.money;
   }

   public static final String PROPERTY_NAME = "name";

   @Property( name = PROPERTY_NAME, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private String name;

   @Property( name = PROPERTY_NAME )
   public void setName (String value)
   {
      this.name = value;
   }

   public Person withName (String value)
   {
      setName (value);
      return this;
   }

   @Property( name = PROPERTY_NAME )
   public String getName ()
   {
      return this.name;
   }

   public void sayHello ()
   {
      boolean fujaba__Success = false;

      // story pattern successor
      try 
      {
         fujaba__Success = false; 

         // constraint getName() != null
         JavaSDM.ensure ( getName() != null );
         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if ( fujaba__Success )
      {
         // story pattern successor
         try 
         {
            fujaba__Success = false; 

            // collabStat call
            System.out.println("I am" +getName() +"!");
            fujaba__Success = true;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      else
      {
         // story pattern storypatternwiththis
         try 
         {
            fujaba__Success = false; 

            // collabStat call
            System.out.println("Strange, I have no name");
            fujaba__Success = true;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      return ;
   }

   public void removeYou()
   {
      this.removeAllFromFriendlyGuard ();
      this.setIsIn (null);
      this.removeAllFromItems ();
   }
}


