/*
 * generated by Fujaba - CodeGen2
 */
package de.uni_kassel.pmss2010.castle;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Room
{



   public static final String PROPERTY_COSTS = "costs";

   @Property( name = PROPERTY_COSTS, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private int costs;

   @Property( name = PROPERTY_COSTS )
   public void setCosts (int value)
   {
      this.costs = value;
   }

   public Room withCosts (int value)
   {
      setCosts (value);
      return this;
   }

   @Property( name = PROPERTY_COSTS )
   public int getCosts ()
   {
      return this.costs;
   }

   /**
    * <pre>
    *           0..n     doors     0..n
    * Room ------------------------- Door
    *           rooms               doors
    * </pre>
    */
   public static final String PROPERTY_DOORS = "doors";

   @Property( name = PROPERTY_DOORS, partner = Door.PROPERTY_ROOMS, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Door> doors;

   @Property( name = PROPERTY_DOORS )
   public Set<? extends Door> getDoors()
   {
      return ((this.doors == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.doors));
   }

   @Property( name = PROPERTY_DOORS )
   public boolean addToDoors (Door value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.doors == null)
         {
            this.doors = new FHashSet<Door> ();

         }
      
         changed = this.doors.add (value);
         if (changed)
         {
            value.addToRooms (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_DOORS )
   public Room withDoors (Door value)
   {
      addToDoors (value);
      return this;
   }

   public Room withoutDoors (Door value)
   {
      removeFromDoors (value);
      return this;
   }


   public boolean removeFromDoors (Door value)
   {
      boolean changed = false;

      if ((this.doors != null) && (value != null))
      {
      
         changed = this.doors.remove (value);
         if (changed)
         {
            value.removeFromRooms (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_DOORS )
   public void removeAllFromDoors (){
   
      Door tmpValue;
      Iterator<? extends Door> iter = this.iteratorOfDoors ();
      while (iter.hasNext ())
      {
         tmpValue = (Door) iter.next ();
         this.removeFromDoors (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_DOORS )
   public boolean hasInDoors (Door value)
   {
      return ((this.doors != null) &&
              (value != null) &&
              this.doors.contains (value));
   }

   @Property( name = PROPERTY_DOORS )
   public Iterator<? extends Door> iteratorOfDoors ()
   {
      return ((this.doors == null)
              ? FEmptyIterator.<Door>get ()
              : this.doors.iterator ());
   }

   @Property( name = PROPERTY_DOORS )
   public int sizeOfDoors ()
   {
      return ((this.doors == null)
              ? 0
              : this.doors.size ());
   }

   /**
    * <pre>
    *           0..1     guards     0..1
    * Room ------------------------- Guard
    *           room               guard
    * </pre>
    */
   public static final String PROPERTY_GUARD = "guard";

   @Property( name = PROPERTY_GUARD, partner = Guard.PROPERTY_ROOM, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Guard guard;

   @Property( name = PROPERTY_GUARD )
   public boolean setGuard (Guard value)
   {
      boolean changed = false;

      if (this.guard != value)
      {
      
         Guard oldValue = this.guard;
         Room source = this;
         if (this.guard != null)
         {
            this.guard = null;
            oldValue.setRoom (null);
         }
         this.guard = value;

         if (value != null)
         {
            value.setRoom (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_GUARD )
   public Room withGuard (Guard value)
   {
      setGuard (value);
      return this;
   }

   public Guard getGuard ()
   {
      return this.guard;
   }

   /**
    * <pre>
    *           0..1     items     0..n
    * Room ------------------------- Item
    *           room               items
    * </pre>
    */
   public static final String PROPERTY_ITEMS = "items";

   @Property( name = PROPERTY_ITEMS, partner = Item.PROPERTY_ROOM, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Item> items;

   @Property( name = PROPERTY_ITEMS )
   public Set<? extends Item> getItems()
   {
      return ((this.items == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.items));
   }

   @Property( name = PROPERTY_ITEMS )
   public boolean addToItems (Item value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.items == null)
         {
            this.items = new FHashSet<Item> ();

         }
      
         changed = this.items.add (value);
         if (changed)
         {
            value.setRoom (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_ITEMS )
   public Room withItems (Item value)
   {
      addToItems (value);
      return this;
   }

   public Room withoutItems (Item value)
   {
      removeFromItems (value);
      return this;
   }


   public boolean removeFromItems (Item value)
   {
      boolean changed = false;

      if ((this.items != null) && (value != null))
      {
      
         changed = this.items.remove (value);
         if (changed)
         {
            value.setRoom (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_ITEMS )
   public void removeAllFromItems (){
   
      Item tmpValue;
      Iterator<? extends Item> iter = this.iteratorOfItems ();
      while (iter.hasNext ())
      {
         tmpValue = (Item) iter.next ();
         this.removeFromItems (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_ITEMS )
   public boolean hasInItems (Item value)
   {
      return ((this.items != null) &&
              (value != null) &&
              this.items.contains (value));
   }

   @Property( name = PROPERTY_ITEMS )
   public Iterator<? extends Item> iteratorOfItems ()
   {
      return ((this.items == null)
              ? FEmptyIterator.<Item>get ()
              : this.items.iterator ());
   }

   @Property( name = PROPERTY_ITEMS )
   public int sizeOfItems ()
   {
      return ((this.items == null)
              ? 0
              : this.items.size ());
   }

   /**
    * <pre>
    *           0..1     isIn     0..1
    * Room ------------------------- Person
    *           isIn               student
    * </pre>
    */
   public static final String PROPERTY_STUDENT = "student";

   @Property( name = PROPERTY_STUDENT, partner = Person.PROPERTY_IS_IN, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Person student;

   @Property( name = PROPERTY_STUDENT )
   public boolean setStudent (Person value)
   {
      boolean changed = false;

      if (this.student != value)
      {
      
         Person oldValue = this.student;
         Room source = this;
         if (this.student != null)
         {
            this.student = null;
            oldValue.setIsIn (null);
         }
         this.student = value;

         if (value != null)
         {
            value.setIsIn (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_STUDENT )
   public Room withStudent (Person value)
   {
      setStudent (value);
      return this;
   }

   public Person getStudent ()
   {
      return this.student;
   }

   /**
    * <pre>
    *           0..n     rooms     0..1
    * Room ------------------------- Castle
    *           rooms               studyRightUniversity
    * </pre>
    */
   public static final String PROPERTY_STUDY_RIGHT_UNIVERSITY = "studyRightUniversity";

   @Property( name = PROPERTY_STUDY_RIGHT_UNIVERSITY, partner = Castle.PROPERTY_ROOMS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Castle studyRightUniversity;

   @Property( name = PROPERTY_STUDY_RIGHT_UNIVERSITY )
   public boolean setStudyRightUniversity (Castle value)
   {
      boolean changed = false;

      if (this.studyRightUniversity != value)
      {
      
         Castle oldValue = this.studyRightUniversity;
         Room source = this;
         if (this.studyRightUniversity != null)
         {
            this.studyRightUniversity = null;
            oldValue.removeFromRooms (this);
         }
         this.studyRightUniversity = value;

         if (value != null)
         {
            value.addToRooms (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_STUDY_RIGHT_UNIVERSITY )
   public Room withStudyRightUniversity (Castle value)
   {
      setStudyRightUniversity (value);
      return this;
   }

   public Castle getStudyRightUniversity ()
   {
      return this.studyRightUniversity;
   }

   public void removeYou()
   {
      this.removeAllFromDoors ();
      this.setGuard (null);
      this.removeAllFromItems ();
      this.setStudent (null);
      this.setStudyRightUniversity (null);
   }
}


